#!/bin/sh
#
#
##############################
# variables assigned by macros
##############################
. theActorPath/WVL_Experiment_Name`_'WVL_Actor_ID`_lib.sh'
logfile=theActorPath/WVL_Experiment_Name`_'WVL_Actor_ID.log
timescript=theActorPath/time
binpath=WVL_SYS_Echo(`WVL_Host_'theHost`_BinPath')
dbpath=WVL_SYS_Echo(`WVL_Component_'theComponent`_DBPath')
changequote([[, ]])dnl

#########################################################
# parse parameter
#########################################################
#
# parse parameters $fileid and $filename
# $filename is the file name for PUT events, while it is the hashkey of the file name for GET events
#
fileid=`echo $parameter|awk -F[,] '{print $1}'`
filename=`echo $parameter|awk -F[,] '{print $2}'`

######################################################
# workload interpretation
# (weevil-defined variables: $event, $parameter, $timestampscript, $actorpath, $comppath, $softwarepath)
######################################################
if [ $event == "PUT" ]
then
    # call timestampscript to log the PUT event with the trial-time
    sh $timestampscript $logfile "put $fileid"
    # call chord client program filestore to insert file $actorpath/$filename
    cd $actorpath
    $timescript -f %e -o $logfile -a $softwarepath/filestore $comppath/sock -s $filename 1 2>> $logfile &
elif [ $event == "GET" ]
then
    # call timestampscript to log the GET event with the trial-time
    sh $timestampscript $logfile "get $fileid"
    # call chord client program filestore to retrieve file with hashkey $fileid
    cd $actorpath
    $timescript -f %e -o $logfile -a $binpath/filestore $dbpath/sock -f $filename 1 2>> $logfile &
elif [ $event == "JOIN" ]
then
    # call timestampscript to log the JOIN event with the trial-time
    sh $timestampscript $logfile "component join"
    sh $compstartscript $compstartargs &
elif [ $event == "LEAVE" ]
then
    # call timestampscript to log the LEAVE event with the trial-time
    sh $timestampscript $logfile "component leave"
    sh $compstopscript &
fi
changequote(`, ')dnl
