#!/bin/sh
################################################
######## global definition block(begin) ########
################################################
SH=/bin/sh
RM=/bin/rm
MV=/bin/mv
SSH=/usr/bin/ssh
SCP=/usr/bin/scp
TOUCH=/usr/bin/touch
RSYNC=/usr/bin/rsync
SLEEP=/bin/sleep
ECHO=/bin/echo
TEST=/usr/bin/test
EXPR=/usr/bin/expr
KILL=/bin/kill
prefix=/usr
PACKAGE=weevil
VERSION=1.2.0
startrunsecs=`date +%s`
WEEVILJAR=${prefix}/lib/${PACKAGE}-${VERSION}/weevilactor.jar
WEEVILSCRIPT=${prefix}/lib/${PACKAGE}-${VERSION}/weevil-sh-actor.sh
${ECHO} 'define(`theNewHosts'"', "'`'theBackupHost"')" >experiment_fix.m4
##############################################
######## global definition block(end) ########
##############################################
###################################
######## link block(begin) ########
###################################
#
# collect experiment files
#
lnstatus=`cat weevil-status/lnstatus`
if [ $lnstatus -eq -1 ]
then
#
# copy the binary distribution of each component type to each machine
#
mkdir -p H0/experiment/SienaServer/software
ln -s /home/tof/apps/weevil-experiments/siena-sschool/binaries/* H0/experiment/SienaServer/software/

mkdir -p H0/experiment
cd H0/experiment
ln -s ../../experiment_H0_terminate.sh experiment_H0_terminate.sh
ln -s ../../experiment_H0_timestamp.sh experiment_H0_timestamp.sh
cd ../../
mkdir -p VH0/experiment/SienaServer/software
ln -s /home/tof/apps/weevil-experiments/siena-sschool/binaries/* VH0/experiment/SienaServer/software/

mkdir -p VH0/experiment
cd VH0/experiment
ln -s ../../experiment_VH0_terminate.sh experiment_VH0_terminate.sh
ln -s ../../experiment_VH0_timestamp.sh experiment_VH0_timestamp.sh
cd ../../
#
# deploy a configuration file, a start and a stop script for each component
#
mkdir -p H0/experiment/SienaServer/S0
cd H0/experiment/SienaServer/S0
${TOUCH} experiment_S0.log
${TOUCH} experiment_S0.err

ln -s ../../../../experiment_S0_start.sh experiment_S0_start.sh
ln -s ../../../../experiment_S0_stop.sh experiment_S0_stop.sh
cd ../../../../
mkdir -p VH0/experiment/SienaServer/S1
cd VH0/experiment/SienaServer/S1
${TOUCH} experiment_S1.log
${TOUCH} experiment_S1.err

ln -s ../../../../experiment_S1_start.sh experiment_S1_start.sh
ln -s ../../../../experiment_S1_stop.sh experiment_S1_stop.sh
cd ../../../../
mkdir -p H0/experiment/SienaServer/S2
cd H0/experiment/SienaServer/S2
${TOUCH} experiment_S2.log
${TOUCH} experiment_S2.err

ln -s ../../../../experiment_S2_start.sh experiment_S2_start.sh
ln -s ../../../../experiment_S2_stop.sh experiment_S2_stop.sh
cd ../../../../
#
# deploy a workload and an actor script for each actor
#
mkdir -p H0/experiment/D0
cd H0/experiment/D0
ln -s ${WEEVILJAR} weevilactor.jar
ln -s ../../../experiment_D0.wkld experiment_D0.wkld
ln -s ../../../experiment_infotable experiment_infotable
ln -s ../../../vxargs vxargs
ln -s ../../.././actor/* ./

cd ../../../
mkdir -p VH0/experiment/D1
cd VH0/experiment/D1
ln -s ${WEEVILJAR} weevilactor.jar
ln -s ../../../experiment_D1.wkld experiment_D1.wkld
ln -s ../../../experiment_infotable experiment_infotable
ln -s ../../../vxargs vxargs
ln -s ../../.././actor/* ./

cd ../../../
mkdir -p H0/experiment/D2
cd H0/experiment/D2
ln -s ${WEEVILJAR} weevilactor.jar
ln -s ../../../experiment_D2.wkld experiment_D2.wkld
ln -s ../../../experiment_infotable experiment_infotable
ln -s ../../../vxargs vxargs
ln -s ../../.././actor/* ./

cd ../../../
#
# deploy a workload and an injector script for each injector
#
#
# deploy a monitor script for each monitor
#
#
# change ln status
#
${ECHO} 0 >weevil-status/lnstatus
fi
#################################
######## link block(end) ########
#################################
#if [ -z "$SSH_AUTH_SOCK" ] ; then
if [ "$SSH_AGENT_PID" == "" ] ; then
      eval `ssh-agent -s`
      ssh-add
fi
#
# record the master process id
#
${ECHO} -n $$ > masterproc.pid
#####################################
######## create block(begin) ########
#####################################
#
# create directories
#
createstatus=`cat weevil-status/createstatus`
if [ $createstatus -ne 0 ]
then
${ECHO} creating experiment file system...
if [ $createstatus -eq -1 ]
then
${TOUCH} weevil-parallel/createtasks
${ECHO} "H0, tof@localhost|mkdir|-p|/home/tof/temp/weevil-tests/demo-run" >> weevil-parallel/createtasks
${ECHO} "VH0, toyuser@192.168.161.130|mkdir|-p|/home/toyuser/demo-run" >> weevil-parallel/createtasks
fi
./vxargs -p -y -P 5 -a weevil-parallel/createtasks -o weevil-parallel/createoutput ${SSH} {}
#
# change create status
#
if [ $? -eq 0 ]
then
${ECHO} $? >weevil-status/createstatus
${RM} -f weevil-parallel/createtasks
else
exitstatus=$?
${ECHO} $exitstatus >weevil-status/createstatus
wholelist="H0 VH0 "
abnormallist="`cat weevil-parallel/createoutput/abnormal_list`"
finishlist="`cat weevil-parallel/createoutput/finish_list`"
failedlist=$wholelist
for j in $finishlist
do
   failedlist=${failedlist/$j/}
done
failedlist=$failedlist' '$abnormallist
for j in $failedlist
do
   grep $j',' weevil-parallel/createtasks >>weevil-parallel/tasksbackup
done
mv weevil-parallel/tasksbackup weevil-parallel/createtasks
exit $exitstatus
fi
fi
###################################
######## create block(end) ########
###################################
###################################
######## copy block(begin) ########
###################################
#
# copy files
#
copystatus=`cat weevil-status/copystatus`
if [ $copystatus -ne 0 ]
then
${ECHO} deploying experiment files...
if [ $copystatus -eq -1 ]
then
${TOUCH} weevil-parallel/copytasks
${ECHO} "H0, H0/experiment|tof@localhost:/home/tof/temp/weevil-tests/demo-run/" >> weevil-parallel/copytasks
${ECHO} "VH0, VH0/experiment|toyuser@192.168.161.130:/home/toyuser/demo-run/" >> weevil-parallel/copytasks
fi
./vxargs -p -y -P 5 -a weevil-parallel/copytasks -o weevil-parallel/copyoutput ${SCP} -r {}
#
# change copy status
#
if [ $? -eq 0 ]
then
${ECHO} $? >weevil-status/copystatus
${RM} -f weevil-parallel/copytasks
else
exitstatus=$?
${ECHO} $exitstatus >weevil-status/copystatus
wholelist="H0 VH0 "
abnormallist="`cat weevil-parallel/copyoutput/abnormal_list`"
finishlist="`cat weevil-parallel/copyoutput/finish_list`"
failedlist=$wholelist
for j in $finishlist
do
   failedlist=${failedlist/$j/}
done
failedlist=$failedlist' '$abnormallist
for j in $failedlist
do
   grep $j',' weevil-parallel/copytasks >>weevil-parallel/tasksbackup
done
mv weevil-parallel/tasksbackup weevil-parallel/copytasks
exit $exitstatus
fi
fi
#################################
######## copy block(end) ########
#################################
stopcopysecs=`date +%s`
deploytime=`${EXPR} $stopcopysecs - $startrunsecs`
${ECHO} The deploy copy time is $deploytime seconds
#######################################
######## start up block(begin) ########
#######################################
#
# starting system components
#
startupstatus=`cat weevil-status/startupstatus`
if [ $startupstatus -ne 0 ]
then
${SSH} tof@localhost /bin/sh /home/tof/temp/weevil-tests/demo-run/experiment/SienaServer/S0/experiment_S0_start.sh  &
srvpid=$!
${ECHO} -n "$srvpid " >> master.pid
srvpids="$srvpids $srvpid"
${ECHO} starting S0...
${SLEEP} 3
${SSH} toyuser@192.168.161.130 /bin/sh /home/toyuser/demo-run/experiment/SienaServer/S1/experiment_S1_start.sh  &
srvpid=$!
${ECHO} -n "$srvpid " >> master.pid
srvpids="$srvpids $srvpid"
${ECHO} starting S1...
${SLEEP} 0
${SSH} tof@localhost /bin/sh /home/tof/temp/weevil-tests/demo-run/experiment/SienaServer/S2/experiment_S2_start.sh  &
srvpid=$!
${ECHO} -n "$srvpid " >> master.pid
srvpids="$srvpids $srvpid"
${ECHO} starting S2...
${SLEEP} 0
#
# change startup status
#
${ECHO} 0 >weevil-status/startupstatus
fi
#####################################
######## start up block(end) ########
#####################################
###############################################
######## monitor start up block(begin) ########
###############################################
#
# starting monitors
#
monitorstartupstatus=`cat weevil-status/monitorstartupstatus`
if [ $monitorstartupstatus -ne 0 ]
then
#
# change startup status
#
${ECHO} 0 >weevil-status/monitorstartupstatus
fi
#############################################
######## monitor start up block(end) ########
#############################################
###########################################
######## testbed monitor block(begin) ########
###########################################
#
# monitoring testbed
#
monitortestbedstatus=`cat weevil-status/monitortestbedstatus`

if [ $monitortestbedstatus -ne 0 ]
then
${ECHO} monitoring hosts...
if [ $monitortestbedstatus -eq -1 ]
then
${TOUCH} weevil-parallel/monitortestbedtasks
${ECHO} "H0, H0|localhost|experiment_terminate.sh|240" >> weevil-parallel/monitortestbedtasks
${ECHO} "VH0, VH0|192.168.161.130|experiment_terminate.sh|240" >> weevil-parallel/monitortestbedtasks
fi
./vxargs -p -y -P 100 -a weevil-parallel/monitortestbedtasks -o weevil-parallel/monitortestbedoutput ${SH} weevil-monitor.sh {} &
#
# change monitor testbed status
#
if [ $? -eq 0 ]
then
${ECHO} $? >weevil-status/monitortestbedstatus
#${RM} -f weevil-parallel/monitortestbedtasks
else
exitstatus=$?
${ECHO} $exitstatus >weevil-status/monitortestbedstatus
wholelist="H0 VH0 "
abnormallist="`cat weevil-parallel/monitortestbedoutput/abnormal_list`"
finishlist="`cat weevil-parallel/monitortestbedoutput/finish_list`"
failedlist=$wholelist
for j in $finishlist
do
   failedlist=${failedlist/$j/}
done
failedlist=$failedlist' '$abnormallist
for j in $failedlist
do
   grep $j',' weevil-parallel/monitortestbedtasks >>weevil-parallel/tasksbackup
done
mv weevil-parallel/tasksbackup weevil-parallel/monitortestbedtasks
exit $exitstatus
fi
fi
###########################################
######## monitortestbed block(end) ########
###########################################
########################################################
######## test start time negotiate block(begin) ########
########################################################
executestatus=`cat weevil-status/executestatus`
if [ $executestatus -ne 0 ]
then
#
# calculating the test time
#
${ECHO} communicating with each host on the testbed to estimate the test start time...
actorhostlist="localhost 192.168.161.130 "
parallelnum=5
#
# ping to get the latency
#
unparalleltimes=1
for j in $actorhostlist
do
  ${ECHO} "$j, $j" >> weevil-parallel/getdelaytasks
done
${ECHO} 0 > base
./vxargs -p -y -P 5 -a weevil-parallel/getdelaytasks -o weevil-parallel/getdelayoutput ${SH} weevil-getdelay.sh {}
negotiatepids="$negotiatepids $!"
${RM} -f weevil-parallel/getdelaytasks
for j in $actorhostlist
do
  RTT0=`cat base`
  RTT=`cat $j`
  compare=$(echo "$RTT0<$RTT" | bc)
  if [ $compare -eq 1 ]
  then
        ${MV} $j base
  else
	${RM} -f $j
  fi
done
RTT=`cat base`
Last=$(${ECHO} "$unparalleltimes*($RTT*0.001+1)" | bc)
${RM} -f base
#
# getting the current time
#
xyear=`date +%Y`
xmonth=`date +%m`
xdayno=`date +%d`
xhour=`date +%H`
xmin=`date +%M`
xsec=`date +%S`
#
# calculating the test time
#
S=$(${ECHO} "$xsec+$Last" | bc)
Left=$(${ECHO} "scale=0 ; $S/60" | bc)
S=59
Mi=`${EXPR} $xmin + $Left`
Left=`${EXPR} $Mi / 60`
Mi=`${EXPR} $Mi % 60`
H=`${EXPR} $xhour + $Left`
Left=`${EXPR} $H / 24`
H=`${EXPR} $H % 24`
D=`${EXPR} $xdayno + $Left`
#
leapjudge=0
case $xmonth in
	01|03|05|07|08|10|12) unit=31 ;;
	04|06|09|11) unit=30 ;;
	*) leapjudge=1 ;
esac
if ${TEST} $leapjudge -eq 1
then
	unit=28
	a=`${EXPR} $xyear % 4`
	if ${TEST} $a -eq 0
	then
		unit=29
	fi
	a=`${EXPR} $xyear % 100`
	if ${TEST} $a -eq 0
	then
		unit=28
	fi
	a=`${EXPR} $xyear % 400`
	if ${TEST} $a -eq 0
	then
		unit=29
	fi
fi
#
Left=`${EXPR} $(($D-1)) '/' $unit`
D=`${EXPR} 1 + $(($D-1)) '%' $unit`
Mo=`${EXPR} $xmonth + $Left`
Left=`${EXPR} $(($Mo-1)) '/' 12`
Mo=`${EXPR} 1 + $(($Mo-1)) '%' 12`
Y=`${EXPR} $xyear + $Left`
testsec=`date --date="$Mo/$D/$Y $H:$Mi:$S" +%s`
stopdeploysecs=`date +%s`
runtime=`${EXPR} $stopdeploysecs - $startrunsecs`
${ECHO} The deploy time is $runtime seconds
######################################################
######## test start time negotiate block(end) ########
######################################################
######################################
######## execute block(begin) ########
######################################
#
# starting clients
#
${ECHO} "The test will start at $Mo/$D/$Y $H:$Mi:$S"
${TOUCH} weevil-parallel/startactortasks/1
${ECHO} "D0, weevil-gettime.sh|$testsec|tof|localhost|/opt/java/bin/java -classpath /home/tof/temp/weevil-tests/demo-run/experiment/D0:/home/tof/temp/weevil-tests/demo-run/experiment/D0/weevilactor.jar:/home/tof/temp/weevil-tests/demo-run/experiment/SienaServer/software:/home/tof/temp/weevil-tests/demo-run/experiment/SienaServer/software/siena-1.5.4.jar WeevilJavaActor|/home/tof/temp/weevil-tests/demo-run/experiment/D0/experiment_D0.wkld SienaActor|ka localhost 4321 4322|D0" >> weevil-parallel/startactortasks/1
${ECHO} "D1, weevil-gettime.sh|$testsec|toyuser|192.168.161.130|/usr/bin/java -classpath /home/toyuser/demo-run/experiment/D1:/home/toyuser/demo-run/experiment/D1/weevilactor.jar:/home/toyuser/demo-run/experiment/SienaServer/software:/home/toyuser/demo-run/experiment/SienaServer/software/siena-1.5.1.jar WeevilJavaActor|/home/toyuser/demo-run/experiment /home/toyuser/demo-run/experiment/D1 experiment_D1.wkld experiment_D1|ka 192.168.161.130 5432 5433|D1" >> weevil-parallel/startactortasks/1
${ECHO} "D2, weevil-gettime.sh|$testsec|tof|localhost|/opt/java/bin/java -classpath /home/tof/temp/weevil-tests/demo-run/experiment/D2:/home/tof/temp/weevil-tests/demo-run/experiment/D2/weevilactor.jar:/home/tof/temp/weevil-tests/demo-run/experiment/SienaServer/software:/home/tof/temp/weevil-tests/demo-run/experiment/SienaServer/software/siena-1.5.1.jar WeevilJavaActor|/home/tof/temp/weevil-tests/demo-run/experiment /home/tof/temp/weevil-tests/demo-run/experiment/D2 experiment_D2.wkld experiment_D2|ka localhost 6543 6544|D2" >> weevil-parallel/startactortasks/1
./vxargs -p -y -P 5 -a weevil-parallel/startactortasks/1 -o weevil-parallel/actorstartoutput/1 ${SH} {} &
${SLEEP} 1
waitornot=1
for (( i=1;i<=$unparalleltimes;i++ )){
   if [ -f weevil-parallel/actorstartoutput/$i/abnormal_list ]
   then
	waitornot=0
   else
	waitpids="$waitpids `cat weevil-parallel/actorstartoutput/$i/pid`"
   fi
}
if [ $waitornot -eq 1 ]
then
   wait $waitpids
else
   echo "Error starting all the actors!"
fi
${RM} -rf weevil-parallel/startactortasks
stoprunsecs=`date +%s`
runtime=`${EXPR} $stoprunsecs - $startrunsecs`
${ECHO} The deploy and execution time is $runtime seconds
${ECHO} killing processes...
${KILL} `cat master.pid`
#
# change execute status
#
${ECHO} 0 >weevil-status/executestatus
fi
####################################
######## execute block(end) ########
####################################
#############################################
######## delete process block(begin) ########
#############################################
#
# stopping system components
#
deletestatus=`cat weevil-status/deletestatus`
if [ $deletestatus -ne 0 ]
then
${ECHO} stoping system components...
if [ $deletestatus -eq -1 ]
then
${TOUCH} weevil-parallel/deletetasks
${ECHO} "H0, tof@localhost|/bin/sh|/home/tof/temp/weevil-tests/demo-run/experiment/experiment_H0_terminate.sh|&" >> weevil-parallel/deletetasks
${ECHO} "VH0, toyuser@192.168.161.130|/bin/sh|/home/toyuser/demo-run/experiment/experiment_VH0_terminate.sh|&" >> weevil-parallel/deletetasks
fi
./vxargs -p -y -P 5 -a weevil-parallel/deletetasks -o weevil-parallel/deleteoutput ${SSH} {}
#
# change delete status
#
if [ $? -eq 0 ]
then
${ECHO} $? >weevil-status/deletestatus
${RM} -f weevil-parallel/deletetasks
else
exitstatus=$?
${ECHO} $exitstatus >weevil-status/deletestatus
wholelist="H0 VH0 "
abnormallist="`cat weevil-parallel/deleteoutput/abnormal_list`"
finishlist="`cat weevil-parallel/deleteoutput/finish_list`"
failedlist=$wholelist
for j in $finishlist
do
   failedlist=${failedlist/$j/}
done
failedlist=$failedlist' '$abnormallist
for j in $failedlist
do
   grep $j',' weevil-parallel/deletetasks >>weevil-parallel/tasksbackup
done
mv weevil-parallel/tasksbackup weevil-parallel/deletetasks
exit $exitstatus
fi
fi
###########################################
######## delete process block(end) ########
###########################################
#############################################
######## copy log files block(begin) ########
#############################################
#
# copying component log files back to master machine
#
copylogstatus=`cat weevil-status/copylogstatus`
if [ $copylogstatus -ne 0 ]
then
${ECHO} copying logs back...
if [ $copylogstatus -eq -1 ]
then
${TOUCH} weevil-parallel/logcopytasks
${ECHO} "S0_0, tof@localhost:/home/tof/temp/weevil-tests/demo-run/experiment/SienaServer/S0/experiment_S0.log|./" >> weevil-parallel/logcopytasks
${ECHO} "S0_1, tof@localhost:/home/tof/temp/weevil-tests/demo-run/experiment/SienaServer/S0/experiment_S0.err|./" >> weevil-parallel/logcopytasks
${ECHO} "S1_0, toyuser@192.168.161.130:/home/toyuser/demo-run/experiment/SienaServer/S1/experiment_S1.log|./" >> weevil-parallel/logcopytasks
${ECHO} "S1_1, toyuser@192.168.161.130:/home/toyuser/demo-run/experiment/SienaServer/S1/experiment_S1.err|./" >> weevil-parallel/logcopytasks
${ECHO} "S2_0, tof@localhost:/home/tof/temp/weevil-tests/demo-run/experiment/SienaServer/S2/experiment_S2.log|./" >> weevil-parallel/logcopytasks
${ECHO} "S2_1, tof@localhost:/home/tof/temp/weevil-tests/demo-run/experiment/SienaServer/S2/experiment_S2.err|./" >> weevil-parallel/logcopytasks
fi
./vxargs -p -y -P 5 -a weevil-parallel/logcopytasks -o weevil-parallel/logcopyoutput ${SCP} -r {}
#
# change copylog status
#
if [ $? -eq 0 ]
then
${ECHO} $? >weevil-status/copylogstatus
${RM} -f weevil-parallel/logcopytasks
else
exitstatus=$?
${ECHO} $exitstatus >weevil-status/copylogstatus
wholelist1="S0_0 S0_1 S1_0 S1_1 S2_0 S2_1 "
wholelist2="D0_0 D1_0 D2_0 "
wholelist3=" "
wholelist=$wholelist1' '$wholelist2' '$wholelist3
abnormallist="`cat weevil-parallel/logcopyoutput/abnormal_list`"
finishlist="`cat weevil-parallel/logcopyoutput/finish_list`"
failedlist=$wholelist
for j in $finishlist
do
   failedlist=${failedlist/$j/}
done
failedlist=$failedlist' '$abnormallist
for j in $failedlist
do
   grep $j',' weevil-parallel/logcopytasks >>weevil-parallel/tasksbackup
done
mv weevil-parallel/tasksbackup weevil-parallel/logcopytasks
exit $exitstatus
fi
fi
###########################################
######## copy log files block(end) ########
###########################################
####################################
######## clean block(begin) ########
####################################
cleanflag=0
#
# cleaning testbed
#
cleanstatus=`cat weevil-status/cleanstatus`
if [ $cleanflag -eq 0 ]
then
cleanstatus=0
fi
if [ $cleanstatus -ne 0 ]
then
${ECHO} cleaning testbed...
if [ $cleanstatus -eq -1 ]
then
${TOUCH} weevil-parallel/cleantasks
${ECHO} "H0, tof@localhost|rm -rf|/home/tof/temp/weevil-tests/demo-run|&" >> weevil-parallel/cleantasks
${ECHO} "VH0, toyuser@192.168.161.130|rm -rf|/home/toyuser/demo-run|&" >> weevil-parallel/cleantasks
fi
./vxargs -p -y -P 5 -a weevil-parallel/cleantasks -o weevil-parallel/cleanoutput ${SSH} {}
#
# change clean status
#
if [ $? -eq 0 ]
then
${ECHO} $? >weevil-status/cleanstatus
${RM} -f weevil-parallel/cleantasks
else
exitstatus=$?
${ECHO} $exitstatus >weevil-status/cleanstatus
wholelist="H0 VH0 "
abnormallist="`cat weevil-parallel/cleanoutput/abnormal_list`"
finishlist="`cat weevil-parallel/cleanoutput/finish_list`"
failedlist=$wholelist
for j in $finishlist
do
   failedlist=${failedlist/$j/}
done
failedlist=$failedlist' '$abnormallist
for j in $failedlist
do
   grep $j',' weevil-parallel/cleantasks >>weevil-parallel/tasksbackup
done
mv weevil-parallel/tasksbackup weevil-parallel/cleantasks
exit $exitstatus
fi
fi
##################################
######## clean block(end) ########
##################################

