dnl -*- m4 -*-
dnl
dnl  This file is part of WEEVIL.
dnl
dnl  Authors: See the file AUTHORS for full details.
dnl
dnl  Copyright (C) 2002-2006 University of Colorado
dnl
dnl  Weevil is free software; you can redistribute it and/or
dnl  modify it under the terms of the GNU General Public License
dnl  as published by the Free Software Foundation; either version 2
dnl  of the License, or (at your option) any later version.
dnl
dnl  Weevil is distributed in the hope that it will be useful,
dnl  but WITHOUT ANY WARRANTY; without even the implied warranty of
dnl  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
dnl  GNU General Public License for more details.
dnl
dnl  You should have received a copy of the GNU General Public License
dnl  along with this program; if not, write to the Free Software
dnl  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301
dnl  USA, or send email to serl@cs.colorado.edu.
dnl
dnl $Id: weevilgen-checks.m4,v 1.1 2007-07-10 13:08:07 wolf Exp $
dnl
dnl
define( `WVL_SYS_Check_Exit', `weevilgen: successfully checked workload')dnl
dnl
dnl
dnl
define( `WVL_SYS_Check_Error', ``define( `WVL_SYS_Check_Exit', ``weevilgen: errors encountered!
'm4exit(1)')'$1')dnl
dnl
dnl
dnl
define( `WVL_SYS_Check_Name', `weevilgen: checking `$1'...ifdef( `$1', `['`$1'`]', WVL_SYS_Check_Error( `error'))')dnl
dnl
dnl
dnl
define( `WVL_SYS_Check_ExternalLibrary', `WVL_SYS_Check_Name( `WVL_ExternalLibrary_'$1)
WVL_SYS_Check_Name( `WVL_ExternalLibrary_'$1`_cflags')
WVL_SYS_Check_Name( `WVL_ExternalLibrary_'$1`_libs')
WVL_SYS_Check_Name( `WVL_ExternalLibrary_'$1`_path')'
)dnl
dnl
dnl
define( `WVL_SYS_Check_WorkloadProcessType', `WVL_SYS_Check_Name( `WVL_WorkloadProcessType_'$1)
WVL_SYS_Check_Name( `WVL_WorkloadProcessType_'$1`_sourceFiles')
WVL_SYS_Foreach( `tmp', `syscmd( `test -f 'tmp)dnl
weevilgen: checking tmp...ifelse( sysval, 0, `exists', WVL_SYS_Check_Error( `does not exist'))
', WVL_SYS_Echo(`WVL_WorkloadProcessType_'$1`_sourceFiles'))dnl
WVL_SYS_Check_Name( `WVL_WorkloadProcessType_'$1`_libraries')
pushdef( `theLibs', `WVL_WorkloadProcessType_'$1`_libraries')dnl
WVL_SYS_Callforeach( `WVL_SYS_Check_ExternalLibrary',theLibs)dnl
popdef( `theLibs')')dnl
dnl
dnl
dnl
define( `WVL_SYS_Check_WorkloadProcess_Exists', `WVL_SYS_Check_Name( `WVL_WorkloadProcess_'$1)')dnl
dnl
dnl
define( `WVL_SYS_Check_WorkloadProcess', `WVL_SYS_Check_Name(`WVL_WorkloadProcess_'$1)
WVL_SYS_Check_Name(`WVL_WorkloadProcess_'$1`_type')
pushdef( `theType', `WVL_WorkloadProcess_'$1`_type')dnl
WVL_SYS_Check_WorkloadProcessType(`theType')dnl
popdef( `theType' )dnl
ifdef(`WVL_WorkloadProcess_'$1`_props', `pushdef( `theProperties', `WVL_WorkloadProcess_'$1`_props')dnl
WVL_SYS_Foreach( `tmp', `WVL_SYS_Check_Name( `WVL_WorkloadProcess_'$1`_'tmp)
', theProperties)dnl
popdef( `theProperties')')dnl
')dnl
dnl
dnl
dnl -------------- begin checks --------------------
dnl
WVL_SYS_Check_Name(`WVL_Workload_ID')
dnl
define(`theWorkload', `WVL_Workload_ID')dnl
WVL_SYS_Check_Name(`WVL_Workload_'theWorkload`_length')
WVL_SYS_Check_Name(`WVL_Workload_'theWorkload`_processes')
dnl
define(`theProcesses', `WVL_Workload_'theWorkload`_processes')dnl
WVL_SYS_Callforeach(`WVL_SYS_Check_WorkloadProcess',theProcesses)dnl
dnl
dnl
dnl
WVL_SYS_Check_Exit
